require_relative 'player'

module StudioGame
  class BerserkPlayer < Player
  
    def initialize(name, health=100)
      super(name, health)
      @w00t_counter = 0
    end
  
    def berserk?
      @w00t_counter > 5
    end
  
    def w00t
      super
      @w00t_counter += 1
      if berserk?
        puts "Watch out! player #{@name} has been w00ted #{@w00t_counter} times."
      else
        puts "Current w00t count of player #{@name}: #{@w00t_counter}"
      end
    end
     
    def blam
      if berserk?
        puts "Ooops! Player #{@name} went beserk! And instead of being blammed, he will be w00ted! (current w00t count: #{@w00t_counter})"
        w00t
      else
        super
      end
    end 
    
      # @w00t_counter >= 5 ? puts "Watch out! This player has been w00ted 5 or more times, to precise - #{@w00t_counter} times." : puts "Current w00t count: #{@w00t_counter}"

      # or use the ternary operator:

      # def blam
        # berserk? ? w00t : super
      # end
  end
end


if __FILE__ == $0
player = BerserkPlayer.new("berserk")
puts player.name
puts player.health
player.w00t
player.w00t
player.w00t
player.w00t
player.w00t
player.w00t
puts player.health
player.blam
puts player.health
player.w00t
puts player.health
player.found_treasure(TreasureTrove::random)
puts player
player.practice

puts
puts
puts

berserker = BerserkPlayer.new("berserker", 50)
6.times { berserker.w00t }
2.times { berserker.blam }
puts berserker.health
end