require_relative 'player'

module StudioGame
  class ClumsyPlayer < Player
  
    attr_reader :boost_factor
  
    def initialize(name, health=100, boost_factor=1)
      super(name, health)
      @boost_factor = boost_factor
    end
  
    def found_treasure(treasure)
  
      damaged_treasure = Treasure.new(treasure.name, treasure.points / 2.0)
    
      super(damaged_treasure)
    end

    def w00t
      @boost_factor.times{super}
      puts "SUPERBOOSTED"
    end

  end
end


if __FILE__ == $0
  clumsy = ClumsyPlayer.new("klutz", 105, 3)  
  
  hammer = Treasure.new(:hammer, 50)
  clumsy.found_treasure(hammer)
  clumsy.found_treasure(hammer)
  clumsy.found_treasure(hammer)
  
  crowbar = Treasure.new(:crowbar, 400)
  clumsy.found_treasure(crowbar)
  
  clumsy.each_found_treasure do |treasure|
    puts "#{treasure.points} total #{treasure.name} points"
  end
  puts "#{clumsy.points} grand total points"
  

  puts
  puts
  puts
  
  
  puts clumsy.health
  clumsy.w00t
  puts clumsy.health
end


=begin

Klutz found a hammer worth 25 points.
Klutz's treasures: {:hammer=>25}.
hammer - 25
Klutz found a hammer worth 25 points.
Klutz's treasures: {:hammer=>50}.
hammer - 50
Klutz found a hammer worth 25 points.
Klutz's treasures: {:hammer=>75}.
hammer - 75
Klutz found a crowbar worth 200 points.
Klutz's treasures: {:hammer=>75, :crowbar=>200}.
hammer - 75
crowbar - 200
75 total hammer points
200 total crowbar points
275 grand total points


Klutz found a hammer worth 50 points.
Klutz's treasures: {:hammer=>50}.
hammer - 50
Klutz found a hammer worth 50 points.
Klutz's treasures: {:hammer=>100}.
hammer - 100
Klutz found a hammer worth 50 points.
Klutz's treasures: {:hammer=>150}.
hammer - 150
Klutz found a crowbar worth 400 points.
Klutz's treasures: {:hammer=>150, :crowbar=>400}.
hammer - 150
crowbar - 400
150 total hammer points
400 total crowbar points
550 grand total points

=end

