require_relative 'treasure_trove'
require_relative 'playable'

module StudioGame
  class Player
    include Playable
  
    attr_accessor :name
    attr_accessor :health

    def initialize(name, health=100)
      @name = name.capitalize
      @health = health
      @found_treasures = Hash.new(0)
    end
  
    def to_s
      "I'm #{@name} with health = #{@health}, points = #{points}, and score = #{score}.\n\n"
    end
  
  
    def score
      self.health + points
    end
  
    def <=>(other)
      other.score <=> score
    end
  
    def found_treasure(treasure)
      @found_treasures[treasure.name] += treasure.points
      puts "#{@name} found a #{treasure.name} worth #{treasure.points} points."
      puts "#{@name}'s treasures: #{@found_treasures}."
      practice
      # puts "#{treasure.name} accumulated #{treasure.points} points."
    end
  
    def points
      @found_treasures.values.reduce(0, :+)
    end
  
    # A
    def each_found_treasure
      @found_treasures.each do |name, points|
        treasure = Treasure.new(name, points)
        yield treasure     # or in one line: yield Treasure.new(name, points)
      end
    end
  
  # another way (alternative for def each_found_treasure)
    def practice
      @found_treasures.each do |key, value|
        print "#{key} - #{value}\n"
      end
    end
  
  end
end

#some example code

if __FILE__ == $0
player = StudioGame::Player.new("moe")
puts player.name
puts player.health
player.w00t
puts player.health
player.blam
puts player.health
player.found_treasure(TreasureTrove::random)
puts player
puts player.score
player.practice
end